# Copyright (C) 2014 Harald Eilertsen
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

module SalesReporter
  class Sale
    attr_reader :date, :amount, :quantity

    def initialize(date_, amount, quantity)
      @date = sanitize_date(date_)
      raise TypeError('sanitize failed') unless @date.is_a? Date
      @amount = amount
      @quantity = quantity
    end

    private

    def sanitize_date(d)
      case d.class.to_s
      when "String"
        return Date.parse(d)
      when "Date"
        return d
      else
        raise TypeError.new('Expected date argument to be of type Date or String')
      end
    end
  end
end
